diff -rNci gcc-2.7.2/unroll.c gcc-2.7.2p/unroll.c
*** gcc-2.7.2/unroll.c	Sat Aug 19 21:33:26 1995
--- gcc-2.7.2p/unroll.c	Tue Jan 23 09:25:32 1996
***************
*** 156,161 ****
--- 156,164 ----
  #include <stdio.h>
  #include "loop.h"
  
+ /* intel1 */
+ extern FILE *loop_dump_stream;
+ 
  /* This controls which loops are unrolled, and by how much we unroll
     them.  */
  
***************
*** 853,871 ****
  	  for (i = 0; i < unroll_number; i++)
  	    labels[i] = gen_label_rtx ();
  
- 	  /* Check for the case where the initial value is greater than or equal
- 	     to the final value.  In that case, we want to execute exactly
- 	     one loop iteration.  The code below will fail for this case.  */
- 
- 	  emit_cmp_insn (initial_value, final_value, neg_inc ? LE : GE,
- 			 NULL_RTX, mode, 0, 0);
- 	  if (neg_inc)
- 	    emit_jump_insn (gen_ble (labels[1]));
- 	  else
- 	    emit_jump_insn (gen_bge (labels[1]));
- 	  JUMP_LABEL (get_last_insn ()) = labels[1];
- 	  LABEL_NUSES (labels[1])++;
- 
  	  /* Assuming the unroll_number is 4, and the increment is 2, then
  	     for a negative increment:	for a positive increment:
  	     diff = 0,1   precond 0	diff = 0,7   precond 0
--- 856,861 ----
***************
*** 882,909 ****
  	  for (i = 0; i < unroll_number - 1; i++)
  	    {
  	      int cmp_const;
- 	      enum rtx_code cmp_code;
  
  	      /* For negative increments, must invert the constant compared
  		 against, except when comparing against zero.  */
  	      if (i == 0)
! 		{
! 		  cmp_const = 0;
! 		  cmp_code = EQ;
! 		}
  	      else if (neg_inc)
! 		{
! 		  cmp_const = unroll_number - i;
! 		  cmp_code = GE;
! 		}
  	      else
! 		{
! 		  cmp_const = i;
! 		  cmp_code = LE;
! 		}
  
  	      emit_cmp_insn (diff, GEN_INT (abs_inc * cmp_const),
! 			     cmp_code, NULL_RTX, mode, 0, 0);
  
  	      if (i == 0)
  		emit_jump_insn (gen_beq (labels[i]));
--- 872,889 ----
  	  for (i = 0; i < unroll_number - 1; i++)
  	    {
  	      int cmp_const;
  
  	      /* For negative increments, must invert the constant compared
  		 against, except when comparing against zero.  */
  	      if (i == 0)
! 		cmp_const = 0;
  	      else if (neg_inc)
! 		cmp_const = unroll_number - i;
  	      else
! 		cmp_const = i;
  
  	      emit_cmp_insn (diff, GEN_INT (abs_inc * cmp_const),
! 			     EQ, NULL_RTX, mode, 0, 0);
  
  	      if (i == 0)
  		emit_jump_insn (gen_beq (labels[i]));
***************
*** 927,946 ****
  	  if (abs_inc != 1)
  	    {
  	      int cmp_const;
- 	      enum rtx_code cmp_code;
  
  	      if (neg_inc)
! 		{
! 		  cmp_const = abs_inc - 1;
! 		  cmp_code = LE;
! 		}
  	      else
! 		{
! 		  cmp_const = abs_inc * (unroll_number - 1) + 1;
! 		  cmp_code = GE;
! 		}
  
! 	      emit_cmp_insn (diff, GEN_INT (cmp_const), cmp_code, NULL_RTX,
  			     mode, 0, 0);
  
  	      if (neg_inc)
--- 907,919 ----
  	  if (abs_inc != 1)
  	    {
  	      int cmp_const;
  
  	      if (neg_inc)
! 		cmp_const = abs_inc - 1;
  	      else
! 		cmp_const = abs_inc * (unroll_number - 1) + 1;
  
! 	      emit_cmp_insn (diff, GEN_INT (cmp_const), EQ, NULL_RTX,
  			     mode, 0, 0);
  
  	      if (neg_inc)
***************
*** 1412,1424 ****
  	 one of the LO_SUM rtx.  */
        if (GET_CODE (increment) == LO_SUM)
  	increment = XEXP (increment, 1);
!       else if (GET_CODE (increment) == IOR
! 	       || GET_CODE (increment) == ASHIFT)
  	{
! 	  /* The rs6000 port loads some constants with IOR.
! 	     The alpha port loads some constants with ASHIFT.  */
  	  rtx second_part = XEXP (increment, 1);
- 	  enum rtx_code code = GET_CODE (increment);
  
  	  src_insn = PREV_INSN (src_insn);
  	  increment = SET_SRC (PATTERN (src_insn));
--- 1385,1394 ----
  	 one of the LO_SUM rtx.  */
        if (GET_CODE (increment) == LO_SUM)
  	increment = XEXP (increment, 1);
!       else if (GET_CODE (increment) == IOR)
  	{
! 	  /* The rs6000 port loads some constants with IOR.  */
  	  rtx second_part = XEXP (increment, 1);
  
  	  src_insn = PREV_INSN (src_insn);
  	  increment = SET_SRC (PATTERN (src_insn));
***************
*** 1429,1438 ****
  	      || GET_CODE (increment) != CONST_INT)
  	    abort ();
  
! 	  if (code == IOR)
! 	    increment = GEN_INT (INTVAL (increment) | INTVAL (second_part));
! 	  else
! 	    increment = GEN_INT (INTVAL (increment) << INTVAL (second_part));
  	}
  
        if (GET_CODE (increment) != CONST_INT)
--- 1399,1405 ----
  	      || GET_CODE (increment) != CONST_INT)
  	    abort ();
  
! 	  increment = GEN_INT (INTVAL (increment) | INTVAL (second_part));
  	}
  
        if (GET_CODE (increment) != CONST_INT)
***************
*** 1770,1775 ****
--- 1737,1778 ----
  	  else
  	    {
  	      pattern = copy_rtx_and_substitute (pattern, map);
+ /* intel1 since a DEST_ADDR giv may be only a part of an address
+    then just substituting reg+const for reg may result in an
+    invalid insn - we check for that and try to make it good */
+ #if REDUCE_INDEX || SAVE_ON_REGS
+               if(GET_CODE(PATTERN(insn))==SET)
+ 	        {
+ 	          int dummy;
+ 	          rtx try_to_make_good(); /* see loop.c */
+ 	          if(recog(pattern,insn,&dummy)==-1)
+ 	            {
+ 	              try_to_make_good(SET_SRC(pattern));
+ 	              try_to_make_good(SET_DEST(pattern));
+   	              if(recog(pattern,insn,&dummy)==-1)
+   	              {
+   	                fprintf(stderr,"bad pattern in insn not better:\n");
+   	                debug_rtx(insn);
+   	                abort();
+   	              }
+ 	            }
+ 	        }
+ #endif
+ 	      /* intel1 Don't want to be reusing STACK_MODE registers
+ 	         since that inhibits scheduling opportunities */
+ #ifdef STACK_REGS
+ #ifdef IS_STACK_MODE
+ #ifdef ONLY_STACK_REG_REORDER
+             if (GET_CODE (pattern) == SET && GET_CODE (SET_DEST (pattern)) == REG
+                 && IS_STACK_MODE (GET_MODE (SET_DEST (pattern))))
+               {
+ 	        tem = gen_reg_rtx (GET_MODE (SET_DEST (pattern)));
+ 	        map->reg_map[REGNO (SET_DEST (PATTERN (insn)))] = tem;
+ 	        SET_DEST (pattern) = tem;
+               }
+ #endif
+ #endif
+ #endif
  	      copy = emit_insn (pattern);
  	    }
  	  REG_NOTES (copy) = initial_reg_note_copy (REG_NOTES (insn), map);
***************
*** 2393,2405 ****
  	 it is unsafe to split the biv since it may not have the proper
  	 value on loop exit.  */
  
!       /* loop_number_exit_count is non-zero if the loop has an exit other than
  	 a fall through at the end.  */
  
        biv_splittable = 1;
        biv_final_value = 0;
        if (unroll_type != UNROLL_COMPLETELY
! 	  && (loop_number_exit_count[uid_loop_num[INSN_UID (loop_start)]]
  	      || unroll_type == UNROLL_NAIVE)
  	  && (uid_luid[regno_last_uid[bl->regno]] >= INSN_LUID (loop_end)
  	      || ! bl->init_insn
--- 2396,2408 ----
  	 it is unsafe to split the biv since it may not have the proper
  	 value on loop exit.  */
  
!       /* loop_number_exit_labels is non-zero if the loop has an exit other than
  	 a fall through at the end.  */
  
        biv_splittable = 1;
        biv_final_value = 0;
        if (unroll_type != UNROLL_COMPLETELY
! 	  && (loop_number_exit_labels[uid_loop_num[INSN_UID (loop_start)]]
  	      || unroll_type == UNROLL_NAIVE)
  	  && (uid_luid[regno_last_uid[bl->regno]] >= INSN_LUID (loop_end)
  	      || ! bl->init_insn
***************
*** 2433,2445 ****
  	    {
  	      /* If the initial value of the biv is itself (i.e. it is too
  		 complicated for strength_reduce to compute), or is a hard
! 		 register, or it isn't invariant, then we must create a new
! 		 pseudo reg to hold the initial value of the biv.  */
  
  	      if (GET_CODE (bl->initial_value) == REG
  		  && (REGNO (bl->initial_value) == bl->regno
! 		      || REGNO (bl->initial_value) < FIRST_PSEUDO_REGISTER
! 		      || ! invariant_p (bl->initial_value)))
  		{
  		  rtx tem = gen_reg_rtx (bl->biv->mode);
  		  
--- 2436,2447 ----
  	    {
  	      /* If the initial value of the biv is itself (i.e. it is too
  		 complicated for strength_reduce to compute), or is a hard
! 		 register, then we must create a new pseudo reg to hold the
! 		 initial value of the biv.  */
  
  	      if (GET_CODE (bl->initial_value) == REG
  		  && (REGNO (bl->initial_value) == bl->regno
! 		      || REGNO (bl->initial_value) < FIRST_PSEUDO_REGISTER))
  		{
  		  rtx tem = gen_reg_rtx (bl->biv->mode);
  		  
***************
*** 2487,2493 ****
  	     loop to ensure that it will always be executed no matter
  	     how the loop exits.  Otherwise emit the insn after the loop,
  	     since this is slightly more efficient.  */
! 	  if (! loop_number_exit_count[uid_loop_num[INSN_UID (loop_start)]])
  	    emit_insn_before (gen_move_insn (bl->biv->src_reg,
  					     biv_final_value),
  			      end_insert_before);
--- 2489,2495 ----
  	     loop to ensure that it will always be executed no matter
  	     how the loop exits.  Otherwise emit the insn after the loop,
  	     since this is slightly more efficient.  */
! 	  if (! loop_number_exit_labels[uid_loop_num[INSN_UID (loop_start)]])
  	    emit_insn_before (gen_move_insn (bl->biv->src_reg,
  					     biv_final_value),
  			      end_insert_before);
***************
*** 2610,2616 ****
  
        final_value = 0;
        if (unroll_type != UNROLL_COMPLETELY
! 	  && (loop_number_exit_count[uid_loop_num[INSN_UID (loop_start)]]
  	      || unroll_type == UNROLL_NAIVE)
  	  && v->giv_type != DEST_ADDR
  	  && ((regno_first_uid[REGNO (v->dest_reg)] != INSN_UID (v->insn)
--- 2612,2618 ----
  
        final_value = 0;
        if (unroll_type != UNROLL_COMPLETELY
! 	  && (loop_number_exit_labels[uid_loop_num[INSN_UID (loop_start)]]
  	      || unroll_type == UNROLL_NAIVE)
  	  && v->giv_type != DEST_ADDR
  	  && ((regno_first_uid[REGNO (v->dest_reg)] != INSN_UID (v->insn)
***************
*** 2950,2975 ****
    rtx insn, label;
    enum rtx_code code;
    int jump_count = 0;
-   int label_count = 0;
-   int this_loop_num = uid_loop_num[INSN_UID (loop_start)];
- 
-   /* In addition to checking all exits of this loop, we must also check
-      all exits of inner nested loops that would exit this loop.  We don't
-      have any way to identify those, so we just give up if there are any
-      such inner loop exits.  */
-      
-   for (label = loop_number_exit_labels[this_loop_num]; label;
-        label = LABEL_NEXTREF (label))
-     label_count++;
- 
-   if (label_count != loop_number_exit_count[this_loop_num])
-     return 0;
  
    /* HACK: Must also search the loop fall through exit, create a label_ref
       here which points to the loop_end, and append the loop_number_exit_labels
       list to it.  */
    label = gen_rtx (LABEL_REF, VOIDmode, loop_end);
!   LABEL_NEXTREF (label) = loop_number_exit_labels[this_loop_num];
  
    for ( ; label; label = LABEL_NEXTREF (label))
      {
--- 2952,2964 ----
    rtx insn, label;
    enum rtx_code code;
    int jump_count = 0;
  
    /* HACK: Must also search the loop fall through exit, create a label_ref
       here which points to the loop_end, and append the loop_number_exit_labels
       list to it.  */
    label = gen_rtx (LABEL_REF, VOIDmode, loop_end);
!   LABEL_NEXTREF (label)
!     = loop_number_exit_labels[uid_loop_num[INSN_UID (loop_start)]];
  
    for ( ; label; label = LABEL_NEXTREF (label))
      {
***************
*** 3048,3054 ****
       value of the biv must be invariant.  */
  
    if (loop_n_iterations != 0
!       && ! loop_number_exit_count[uid_loop_num[INSN_UID (loop_start)]]
        && invariant_p (bl->initial_value))
      {
        increment = biv_total_increment (bl, loop_start, loop_end);
--- 3037,3043 ----
       value of the biv must be invariant.  */
  
    if (loop_n_iterations != 0
!       && ! loop_number_exit_labels[uid_loop_num[INSN_UID (loop_start)]]
        && invariant_p (bl->initial_value))
      {
        increment = biv_total_increment (bl, loop_start, loop_end);
***************
*** 3126,3132 ****
       to be known.  */
  
    if (loop_n_iterations != 0
!       && ! loop_number_exit_count[uid_loop_num[INSN_UID (loop_start)]])
      {
        /* ?? It is tempting to use the biv's value here since these insns will
  	 be put after the loop, and hence the biv will have its final value
--- 3115,3121 ----
       to be known.  */
  
    if (loop_n_iterations != 0
!       && ! loop_number_exit_labels[uid_loop_num[INSN_UID (loop_start)]])
      {
        /* ?? It is tempting to use the biv's value here since these insns will
  	 be put after the loop, and hence the biv will have its final value
diff -rNci gcc-2.7.2/varasm.c gcc-2.7.2p/varasm.c
*** gcc-2.7.2/varasm.c	Thu Aug 31 23:02:53 1995
--- gcc-2.7.2p/varasm.c	Tue Jan 23 09:25:32 1996
***************
*** 78,90 ****
  
  /* Number for making the label on the next
     constant that is stored in memory.  */
! 
! int const_labelno;
  
  /* Number for making the label on the next
     static variable internal to a function.  */
! 
! int var_labelno;
  
  /* Carry information from ASM_DECLARE_OBJECT_NAME
     to ASM_FINISH_DECLARE_OBJECT.  */
--- 78,90 ----
  
  /* Number for making the label on the next
     constant that is stored in memory.  */
! /* intel1 */
! static int const_labelno = 0;
  
  /* Number for making the label on the next
     static variable internal to a function.  */
! /* intel1 */
! int var_labelno = 0;
  
  /* Carry information from ASM_DECLARE_OBJECT_NAME
     to ASM_FINISH_DECLARE_OBJECT.  */
***************
*** 1147,1158 ****
  	    else
  	      {
  #ifdef ASM_OUTPUT_ALIGNED_COMMON
! 		ASM_OUTPUT_ALIGNED_COMMON (asm_out_file, name, size,
! 					   DECL_ALIGN (decl));
  #else
! 		ASM_OUTPUT_COMMON (asm_out_file, name, size, rounded);
  #endif
! 	      }
  	}
        else
  	{
--- 1147,1169 ----
  	    else
  	      {
  #ifdef ASM_OUTPUT_ALIGNED_COMMON
! /* intel1 */
! #ifdef ALIGN_DFmode
!               if (DECL_MODE (decl) == DFmode
!                   && DECL_ALIGN (decl) 
!                     == (GET_MODE_SIZE (SFmode) * BITS_PER_UNIT))
!                 {
! 	      ASM_OUTPUT_ALIGNED_COMMON (asm_out_file, name, size, 
! 	      GET_MODE_SIZE (DFmode) * BITS_PER_UNIT);
!                 }
!               else
! #endif
! 	      ASM_OUTPUT_ALIGNED_COMMON (asm_out_file, name, size,
! 	 	 		         DECL_ALIGN (decl));
  #else
! 	      ASM_OUTPUT_COMMON (asm_out_file, name, size, rounded);
  #endif
! 		}
  	}
        else
  	{
***************
*** 1168,1179 ****
  	    else
  	      {
  #ifdef ASM_OUTPUT_ALIGNED_LOCAL
! 		ASM_OUTPUT_ALIGNED_LOCAL (asm_out_file, name, size,
! 					  DECL_ALIGN (decl));
  #else
! 		ASM_OUTPUT_LOCAL (asm_out_file, name, size, rounded);
  #endif
! 	      }
  	}
        goto finish;
      }
--- 1179,1201 ----
  	    else
  	      {
  #ifdef ASM_OUTPUT_ALIGNED_LOCAL
! /* intel1 */
! #ifdef ALIGN_DFmode
!             if (DECL_MODE (decl) == DFmode
!                 && DECL_ALIGN (decl) 
!                   == (GET_MODE_SIZE (SFmode) * BITS_PER_UNIT))
!               {
! 	    ASM_OUTPUT_ALIGNED_COMMON (asm_out_file, name, size, 
! 	    GET_MODE_SIZE (DFmode) * BITS_PER_UNIT);
!               }
!             else
! #endif
! 	    ASM_OUTPUT_ALIGNED_LOCAL (asm_out_file, name, size,
! 				      DECL_ALIGN (decl));
  #else
! 	    ASM_OUTPUT_LOCAL (asm_out_file, name, size, rounded);
  #endif
! 		}
  	}
        goto finish;
      }
***************
*** 1327,1332 ****
--- 1349,1362 ----
       from it in get_pointer_alignment.  */
    DECL_ALIGN (decl) = align;
  
+ /* intel1 */
+ #ifdef ALIGN_DFmode
+     if (DECL_MODE (decl) == DFmode
+         && DECL_ALIGN (decl) == (GET_MODE_SIZE (SFmode) * BITS_PER_UNIT))
+       {
+         align = GET_MODE_SIZE (DFmode) * BITS_PER_UNIT;
+       }
+ #endif
    if (align > BITS_PER_UNIT)
      {
        if (output_bytecode)
***************
*** 1575,1581 ****
    if (name[0] == '*')
      {
        if (output_bytecode)
! 	bc_emit_labelref (name, 0);
        else
  	fputs (&name[1], file);
      }
--- 1605,1611 ----
    if (name[0] == '*')
      {
        if (output_bytecode)
! 	bc_emit_labelref (name);
        else
  	fputs (&name[1], file);
      }
***************
*** 2954,2960 ****
    union {
      union real_extract du;
      struct addr_const addr;
-     struct {HOST_WIDE_INT high, low;} di;
    } un;
  };
  
--- 2984,2989 ----
***************
*** 2985,3000 ****
      case CONST_DOUBLE:
        value->kind = RTX_DOUBLE;
        if (GET_MODE (x) != VOIDmode)
! 	{
! 	  value->mode = GET_MODE (x);
! 	  bcopy ((char *) &CONST_DOUBLE_LOW (x),
! 		 (char *) &value->un.du, sizeof value->un.du);
! 	}
!       else
! 	{
! 	  value->un.di.low = CONST_DOUBLE_LOW (x);
! 	  value->un.di.high = CONST_DOUBLE_HIGH (x);
! 	}
        break;
  
      case CONST_INT:
--- 3014,3022 ----
      case CONST_DOUBLE:
        value->kind = RTX_DOUBLE;
        if (GET_MODE (x) != VOIDmode)
! 	value->mode = GET_MODE (x);
!       bcopy ((char *) &CONST_DOUBLE_LOW (x),
! 	     (char *) &value->un.du, sizeof value->un.du);
        break;
  
      case CONST_INT:
***************
*** 3198,3203 ****
--- 3220,3229 ----
        align = (mode == VOIDmode) ? UNITS_PER_WORD : GET_MODE_SIZE (mode);
        if (align > BIGGEST_ALIGNMENT / BITS_PER_UNIT)
  	align = BIGGEST_ALIGNMENT / BITS_PER_UNIT;
+       /* intel1 */
+ #ifdef ALIGN_DFmode
+       align = (mode == DFmode) ? GET_MODE_SIZE (mode) : align;
+ #endif
  
        pool_offset += align - 1;
        pool_offset &= ~ (align - 1);
***************
*** 3693,3700 ****
    else
      if (size == 4
  	&& TREE_CODE (TREE_OPERAND (addr_part, 0)) == VAR_DECL)
!       bc_emit_labelref (IDENTIFIER_POINTER
! 			(DECL_ASSEMBLER_NAME (TREE_OPERAND (addr_part, 0))),
  			TREE_INT_CST_LOW (const_part));
      else
        abort ();		/* FIXME: there may be more cases.  */
--- 3719,3725 ----
    else
      if (size == 4
  	&& TREE_CODE (TREE_OPERAND (addr_part, 0)) == VAR_DECL)
!       bc_emit_labelref (DECL_ASSEMBLER_NAME (TREE_OPERAND (addr_part, 0)),
  			TREE_INT_CST_LOW (const_part));
      else
        abort ();		/* FIXME: there may be more cases.  */
diff -rNci gcc-2.7.2/version.c gcc-2.7.2p/version.c
*** gcc-2.7.2/version.c	Sun Nov 26 16:20:43 1995
--- gcc-2.7.2p/version.c	Tue Jan 23 09:54:59 1996
***************
*** 1 ****
! char *version_string = "2.7.2";
--- 1 ----
! char *version_string = "2.7.2p";
